;                                                                                    
;                                                                                    
;                                                                            
;                                                                             
;                                                                          
;                                                                     
;                                                                                
;                                                                                          
;		by pacHa

;	$937a

.include	acebeta.inc

.db	$cd,"Snake",6,$81,".",$81,$81,0	; *Snake 1.11

pos_x			=	SH_BUF
pos_y			=	SH_BUF + 1
direction		=	SH_BUF + 2
_matrix		=	SH_BUF + 4		; 8 * 12 matrix --> 96 bytes
_list			=	SH_BUF + 100	; 192 bytes list
pointer_list	=	SH_BUF + 292	; pointer to the current position of the snake in the list
length		=	SH_BUF + 293	; length of the snake
temp_x		=	SH_BUF + 294
temp_y		=	SH_BUF + 295
eaten			=	SH_BUF + 296	; number of apples eaten
apple_x		=	SH_BUF + 297
apple_y		=	SH_BUF + 298
;speed			=	SH_BUF + 299
current_speed	=	SH_BUF + 300


	res	2,(iy+$0d)			; does'nt scroll

	call	_title

	ld	hl,$0407
	ld	(CURSOR_POS),hl
	ld	hl,txt_preso
	CALL	D_ZT_STR

	ld	hl,$0403
	ld	(CURSOR_POS),hl
	ld	hl,txt_speed
	CALL	D_ZT_STR
	;ld	a,1
	;ld	(speed),a
	
_speed:
	ld	hl,$0a03
	ld	(CURSOR_POS),hl
	ld	a,(speed)
	add	a,$30
	CALL	TX_CHARPUT

	CALL	GET_KEY
	cp	G_RIGHT
	call	z,fill_GRAPH_MEM
	cp	G_LEFT
	call	z,clear_GRAPH_MEM
	cp	G_0
	call	z,high_to_zero		; clears the highscore
	cp	G_UP
	jp	z,speed_plus
	cp	G_DOWN
	jp	z,speed_moins
	or	a
	jr	z,_speed

;---------------------------- variables initializing

	ld	a,(speed)
	ld	b,a
	add	a,a
	add	a,b
	ld	(current_speed),a

	ld	hl,_matrix			; clears the _matrix and the _list
	ld	de,_matrix + 1
	ld	(hl),0
	ld	bc,288
	ldir

	ld	hl,pos_x		
	ld	(hl),$01		; pos_x = 1
	inc	hl
	ld	(hl),$01		; pos_y = 1
	inc	hl
	ld	(hl),$01		; direction = 1
	ld	a,6
	ld	(pointer_list),a	; pointer_list = 6
	ld	a,2
	ld	(length),a		; length = 2
	xor	a
	ld	(eaten),a

;-----------------------------------

	call	apple_y_gen				; a new apple

debut:

	call	_list_actualize

	ld	a,(pointer_list)
	inc	a
	inc	a
	ld	(pointer_list),a
	cp	192
	call	z,pointertozero

	jp	check_collision

apres_1:
	call	_matrix_actualize			; stores 1 where the head is, 0 where the queue is and 2 where the apple is.

	ld	a,(pos_y)
	call	coord_calc
	ld	e,a

	ld	a,(pos_x)
	call	coord_calc

	ld	bc,body
	call	PutSprite

	call	clear_queue

	CALL	DISP_GRAPH

	ld	a,(current_speed)
	ld	b,a
slow:
	halt
	djnz	slow

	CALL	GET_KEY
	cp	G_RIGHT
	jr	z,right
	cp	G_DOWN
	jr	z,down
	cp	G_LEFT
	jr	z,left
	cp	G_UP
	jr	z,up
	cp	G_CLEAR
	call	z,powerdown
	cp	G_DEL
	call	z,thepause

	ld	a,(direction)
	cp	1
	jr	z,right
	cp	2
	jr	z,down
	cp	3
	jr	z,left
	cp	4
	jr	z,up

	jp	debut

right:
	ld	a,1
	ld	(direction),a
	ld	a,(pos_x)
	inc	a
	ld	(pos_x),a
	cp	$0d
	call	z,un_x
	jp	debut

down:
	ld	a,2
	ld	(direction),a
	ld	a,(pos_y)
	inc	a
	ld	(pos_y),a
	cp	$09
	call	z,un_y
	jp	debut

left:
	ld	a,3
	ld	(direction),a
	ld	a,(pos_x)
	dec	a
	ld	(pos_x),a
	call	z,douze_x
	jp	debut

up:
	ld	a,4
	ld	(direction),a
	ld	a,(pos_y)
	dec	a
	ld	(pos_y),a
	call	z,huit_y
	jp	debut

un_x:
	ld	a,1
	ld	(pos_x),a
	ret

un_y:
	ld	a,1
	ld	(pos_y),a
	ret

douze_x:
	ld	a,12
	ld	(pos_x),a
	ret

huit_y:
	ld	a,8
	ld	(pos_y),a
	ret

coord_calc:
	dec	a
	add	a,a
	add	a,a
	add	a,a
	ret

_matrix_actualize:			; actualizes the _matrix
	ld	a,(pos_x)
	ld	(temp_x),a
	ld	a,(pos_y)
	ld	(temp_y),a
	call	coord_calc_matrix
	ld	(hl),1			; 1 at the snake's head

	ld	a,(apple_x)
	ld	(temp_x),a
	ld	a,(apple_y)
	ld	(temp_y),a
	call	coord_calc_matrix
	ld	(hl),2			; 2 at the apple

	call	calc_coord_clear
	ld	a,(hl)
	ld	(temp_x),a
	inc	hl
	ld	a,(hl)
	ld	(temp_y),a
	call	coord_calc_matrix
	ld	(hl),0			; 0 at the queue
	ret

check_collision:				; checks for collision
	ld	a,(pos_x)
	ld	(temp_x),a
	ld	a,(pos_y)
	ld	(temp_y),a
	call	coord_calc_matrix
	ld	a,(hl)
	cp	1				; if it's some snake
	jp	z,fin				; ... you lose
	cp	2				; if it's an apple
	call	z,newapple			; ... go for a new one!
	jp	apres_1

coord_calc_matrix:			; input = temp_x and temp_y holds the x and y coords
	ld	a,(temp_y)			; output = hl holds the addresss in the _matrix
	dec	a
	ld	l,a
	ld	h,12
;	CALL	$1f18			; hl = h*l	19.0
	CALL	$2043			; hl = h*l	19.006
	ld	a,(temp_x)
	ld	d,$00
	ld	e,a
	dec	a
	add	hl,de
	ld	de,_matrix
	add	hl,de
	dec	hl
	ret

coord_calc_list:				; input = none   output = hl holds the address in the _list
	ld	a,(pointer_list)
	ld	l,a
	ld	h,$00
	ld	de,_list
	add	hl,de
	ret

_list_actualize:				; actualizes the _matrix
	call	coord_calc_list
	ld	a,(pos_x)
	ld	(hl),a
	inc	hl
	ld	a,(pos_y)
	ld	(hl),a
	ret

pointertozero:
	xor	a
	ld	(pointer_list),a
	ret

add_hl_list:
	ld	de,192
	add	hl,de
	ret

calc_coord_clear:
	call	coord_calc_list
	ld	a,(length)
	ld	b,a
subtract:
	dec	hl
	dec	hl
	djnz	subtract
	ld	de,_list
	CALL	CP_HL_DE
	call	c,add_hl_list
	ret

newapple:
	ld	hl,length
	inc	(hl)
	call	clear_queue
	ld	a,(apple_x)
	ld	(temp_x),a
	ld	a,(apple_y)
	ld	(temp_y),a
	call	coord_calc_matrix
	xor	a
	ld	(hl),a
	call	xor_apple
	ld	hl,eaten
	inc	(hl)
apple_y_gen:
	CALL	RAND
	call	srl_5		; does 'srl a' 5 times 
	jr	z,apple_y_gen
	ld	(apple_y),a
apple_x_gen:
	CALL	RAND
	call	srl_5		; "     "     "     "
	srl	a
	ld	(apple_x),a
	CALL	RAND
	call	srl_5		; "     "     "     "
	ld	b,a
	ld	a,(apple_x)
	add	a,b
	ld	(apple_x),a
	jr	z,apple_x_gen
	call	xor_apple
	ret

xor_apple:
	ld	a,(apple_y)
	call	coord_calc
	ld	e,a

	ld	a,(apple_x)
	call	coord_calc
	ld	bc,apple_sprite
	call	PutSprite
	CALL	DISP_GRAPH
	ret

clear_queue:
	call	calc_coord_clear

	ld	a,(hl)
	call	coord_calc
	ld	b,a

	inc	hl
	ld	a,(hl)
	call	coord_calc
	ld	e,a
	ld	a,b

	ld	bc,body
	call	PutSprite				; XORs the body (=clears it)
	ret

clear_GRAPH_MEM:
	ld	hl,GRAPH_MEM		; clears the GRAPH_MEM
	ld	de,GRAPH_MEM + 1
	ld	(hl),0
	ld	bc,767
	ldir
	ret

fill_GRAPH_MEM:
	ld	hl,GRAPH_MEM		; fills the GRAPH_MEM
	ld	de,GRAPH_MEM + 1
	ld	(hl),$ff
	ld	bc,767
	ldir
	ret

txt_preso:
	.db	"by pacHa",0

body:
	.db	%01111110
	.db	%11011011
	.db	%10001001
	.db	%11100011
	.db	%11000111
	.db	%10010001
	.db	%11011011
	.db	%01111110

apple_sprite:
	.db	%00001100
	.db	%00001000
	.db	%01101110
	.db	%10011001
	.db	%10000001
	.db	%10000001
	.db	%10000001
	.db	%01111110

title:
                     .db %00000011,%11100100,%00001100,%00000100,%00000000,%11110000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000010,%00000100,%00111000,%11000100,%00011001,%00011000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000011,%11100100,%01100011,%11000110,%01110011,%00011000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00010000,%00100110,%01000110,%01110011,%11000011,%11110000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00010000,%00101111,%01001111,%11100011,%11100001,%10000001,%10000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00011000,%01101001,%11001110,%01000110,%00011000,%11111110,%00110000,%11011000,%00000000,%00000000
 .db %00000000,%00000000,%00001111,%11001001,%10011000,%11000010,%00001000,%00000000,%00010000,%01001000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00010000,%00010000,%10000010,%00000000,%00000000,%00010100,%01001000 ; 4 bytes saved
													; by leaving off 4 '.db %00000000' !

fin:
	call	clear_GRAPH_MEM
	call	_title
	ld	hl,$0003
	ld	(CURSOR_POS),hl
	ld	hl,txt_lose
	CALL	D_ZT_STR
	ld	hl,eaten
	ld	a,(hl)
	ld	b,a
	ld	a,(highscore)
	cp	b
	call	c,newhigh
	ld	l,(hl)
	ld	h,$00
;	CALL	$3896		; D_HL_DECI 19.0
	CALL	$39af		; D_HL_DECI 19.006
	ld	hl,$0706
	ld	(CURSOR_POS),hl
	ld	hl,txt_high
	CALL	D_ZT_STR
	ld	a,(highscore)
	ld	l,a
	ld	h,$00
;	CALL	$3896		; D_HL_DECI 19.0
	CALL	$39af		; D_HL_DECI 19.006
	ld	hl,$0707
	ld	(CURSOR_POS),hl
	ld	hl,txt_speed
	CALL	D_ZT_STR
	res	2,(iy+$0d)			; does'nt scroll
	ld	hl,$0f07
	ld	(CURSOR_POS),hl
	ld	a,(high_speed)
	add	a,$30
	CALL	TX_CHARPUT
	CALL	PAUSE
	ret

newhigh:
	ld	a,b
	ld	(highscore),a
	ld	a,(speed)
	ld	(high_speed),a
	ret

highscore:
	.db	0

high_speed:
	.db	0

txt_speed:
	.db	"Speed",0
;	.ds	5			; machin ki f chi

speed:
	.db	3

txt_lose:
	.db	"Score",0


txt_high:
	.db	"High",0

_title:
	ld	hl,title
	ld	de,GRAPH_MEM + (4*12) + 2
	ld	bc,(8*12)-4
	ldir
	CALL	DISP_GRAPH
	ret

srl_5:
	srl	a
	srl	a
	srl	a
	srl	a
	srl	a
	ret

powerdown:
;	call	$7ea		; power down 19.0
	call	$831		; power down 19.006
thepause:
	CALL	GET_KEY
	cp	G_RIGHT
	jp	z,right
	cp	G_DOWN
	jp	z,down
	cp	G_LEFT
	jp	z,left
	cp	G_UP
	jp	z,up
	cp	G_CLEAR
	jp	z,EXIT_TIOS
	jr	thepause

high_to_zero:
	xor	a
	ld	(highscore),a
	ret

speed_plus:
	ld	a,(speed)
	cp	9
	jp	z,_speed
	inc	a
	ld	(speed),a
	jp	_speed

speed_moins:
	ld	a,(speed)
	cp	1
	jp	z,_speed
	dec	a
	ld	(speed),a
	jp	_speed

;Ŀ
; Z80 ۳    Sprite83    ۳ movax ۳
;

; Sprite xor routine v1.0
; Coded by Hannes Edfeldt in 1997

; This routine uses xor to draw the sprite, therefore you can erase the sprite
; by just drawing it again at the same x and y coordinates. See xordemo.z80
; for an example of how to use this routine.

; Feel free to use this routine in your own productions as long as you give me
; some credit.

; This file should of course be viewed in a DOS texteditor ;)

; Hannes Edfeldt -+- movax@algonet.se -+- http://www.algonet.se/~movax


; SPRXOR  Modified by pacHa
;Ŀ 22/11/2002
; Xor 8x8 sprite  a=x, e=y, bc=sprite address                               
;
PutSprite:

        push    bc              ; Save sprite address

;   Calculate the address in graphbuf   

        ld      hl,0            ; Do y*12
        ld      d,0
        add     hl,de
        add     hl,de
        add     hl,de
        add     hl,hl
        add     hl,hl

        ld      d,0             ; Do x/8
        ld      e,a
        srl     e
        srl     e
        srl     e
        add     hl,de

        ld      de,$88B8
        add     hl,de           ; Add address to graphbuf

		;        ld      b,00000111b     ; Get the remainder of x/8
		;       and     b
		;        cp      0
		;        jp      z,ALIGN


		;   Non aligned sprite blit starts here   
		;
		;       pop     ix              ; ix->sprite
		;        ld      d,a             ; d=how many bits to shift each line
		;
		;        ld      e,8             ; Line loop
		;LILOP:  ld      b,(ix+0)        ; Get sprite data

		;        ld      c,0             ; Shift loop
		;        push    de
		;SHLOP:  srl     b
		;        rr      c
		;        dec     d
		;        jp      nz,SHLOP
		;        pop     de

		;        ld      a,b             ; Write line to graphbuf
		;        xor     (hl)
		;        ld      (hl),a
		;        inc     hl
		;        ld      a,c
		;        xor     (hl)
		;        ld      (hl),a

		;        ld      bc,11           ; Calculate next line address
		;        add     hl,bc
		;        inc     ix              ; Inc spritepointer

		;        dec     e
		;        jp      nz,LILOP        ; Next line

		;       jp      DONE1


;   Aligned sprite blit starts here   

ALIGN:                          ; Blit an aligned sprite to graphbuf
        pop     de              ; de->sprite
        ld      b,8
ALOP1:  ld      a,(de)
        xor     (hl)
        ld      (hl),a
        inc     de
        push    bc
        ld      bc,12
        add     hl,bc
        pop     bc
        djnz    ALOP1

DONE1:
        ret

; SPRXOR 

.end
